Subject: Re: stmmac/RTL8211F/Meson GXBB: TX throughput problems

From: Jerome Brunet <[email-masked]>
Date: Mon, 14 Nov 2016 12:02:20 +0100

On Mon, 2016-11-14 at 08:47 +0100, Giuseppe CAVALLARO wrote:
> Hello Martin
> 
> On 11/7/2016 6:37 PM, Martin Blumenstingl wrote:
> > 
> > Hi Peppe,
> > 
> > On Mon, Nov 7, 2016 at 11:59 AM, Giuseppe CAVALLARO
> > <[email-masked]> wrote:
> > > 
> > > In the meantime, I will read again the thread just to see if
> > > there is something I am missing.
> > if you are re-reading this thread: please note that there are two
> > devices in discussion here!
> 
> many thx for the sum :-)
> 
> > 
> > Both are using the Amlogic S905 (GXBB) SoC and both are
> > experiencing
> > the same issue (Gbit TX issues, RX with Gbit speeds and RX/TX with
> > 100Mbit speed are NOT affected):
> > - Odroid-C2 (used by Jerome and André Roth)
> > - Tronsmart Vega S95 Meta (my device)
> > 
> > The (Gbit TX) problem seems to be gone on the Odroid-C2 with
> > Jerome's
> > patch which disables EEE in drivers/net/phy/realtek.c (at least in
> > his
> > tests, I don't have that device so I can't verify).
> > The same problem still appears on my Tronsmart Vega S95 Meta even
> > with
> > the patched PHY driver.
> 
> just an doubt, maybe useful, in the past, on GiGa setup I saw similar
> problems and it was due to retiming so maybe 2ns could be necessary
> (or better granularity via PAD logic if available).
> 
> Regards
> Peppe

Peppe, Martin,

With Andre's feedback, I think we can confirm that disabling EEE solve
the problem for the OdroidC2 design.

We do have the same results as Martin on MXQ-Pro based designs. For
these particular boards, disabling EEE does not seems to enough to get
a stable Tx path in 1000Base-T.

I will submit the patch for the Odroidc2 later today.
For the Vega, you should probably check the Tx delay as Peppe suggests.
To do these tests, It would probably be better to disable EEE as well.
Do you want me to include this change for the vega in the patch ?

Cheers
Jerome 

> 
> > 
> > Unfortunately I don't have a second device to rule out that my
> > Tronsmart Vega S95 Meta could be broken (not unlikely, I get DDR
> > errors from time to time in u-boot). Maybe Andreas Faerber can test
> > ethernet with and without Jerome's patch on one of his Tronsmart
> > devices.
> > 
> > 
> > Regards,
> > Martin
> > 
>